package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    private T[] array;

    public ArrayUtility(T[] inputArray) {
        this.array = inputArray;
    }

    public T[] mergeArrays(T[] inputArray, T[] arrayToMerge) {
        T[] mergedArray = (T[]) Array.newInstance(this.array.getClass().getComponentType(), this.array.length + arrayToMerge.length);

        for (int i = 0; i < mergedArray.length; i++) {
            if (i < inputArray.length) {
                mergedArray[i] = inputArray[i];
            } else {
                mergedArray[i] = arrayToMerge[i - inputArray.length];
            }
        }
        return mergedArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        T[] mergedArray = mergeArrays(this.array, arrayToMerge);
        int count = 0;

        for (T element : mergedArray) {
            if (element == valueToEvaluate) {
                count++;
            }
        }
        return count;
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] mergedArray = mergeArrays(this.array, arrayToMerge);
        int mostCommonCount = 0;
        T mostCommon = mergedArray[0];

        for (int i = 0; i < mergedArray.length; i++) {
            if (getNumberOfOccurrences(mergedArray[i]) > mostCommonCount) {
                mostCommonCount = getNumberOfOccurrences(mergedArray[i]);
                mostCommon = mergedArray[i];
            }
        }
        return mostCommon;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;

        for (T element : this.array) {
            if (element == valueToEvaluate) {
                count++;
            }
        }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
        T[] newArrayWithout = (T[]) Array.newInstance(this.array.getClass().getComponentType(), this.array.length - getNumberOfOccurrences(valueToRemove));
        int j = 0;

        for (int i = 0; i < this.array.length; i++) {
            if (this.array[i] != valueToRemove) {
                newArrayWithout[j] = this.array[i];
                j++;
            }
        }
        return newArrayWithout;
    }

}
